<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="100px"
    >
<!--      <el-form-item label="钥匙编码" prop="keyCode">-->
<!--        <el-input-->
<!--          v-model="queryParams.keyCode"-->
<!--          placeholder="请输入钥匙编码"-->
<!--          clearable-->
<!--          @keyup.enter="handleQuery"-->
<!--          class="!w-240px"-->
<!--        />-->
<!--      </el-form-item>-->
      <el-form-item label="钥匙名称" prop="keyName">
        <el-input
          v-model="queryParams.keyName"
          placeholder="请输入钥匙名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['mes:hw:key:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="danger"
          plain
          :disabled="!selectedIds.length"
          @click="handleDelete()"
          v-hasPermi="['mes:hw:key:delete']"
        >
          <Icon icon="ep:delete" class="mr-5px" /> 批量删除
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table
      v-loading="loading"
      :data="list"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
<!--      <el-table-column label="钥匙编码" prop="keyCode" width="150" />-->
      <el-table-column label="钥匙名称" prop="keyName" width="180" />
      <el-table-column label="钥匙NFC" prop="keyNfc" width="180" :show-overflow-tooltip="true" />
      <el-table-column label="钥匙型号" prop="keySpec" width="180" :show-overflow-tooltip="true" />
      <el-table-column label="MAC地址" prop="macAddress" />
      <el-table-column label="状态" prop="exStatus">
        <template #default="scope">
          <el-switch
            v-if="scope.row.exStatus !== null"
            v-model="scope.row.exStatus"
            active-value="1"
            inactive-value="0"
            active-color="#13ce66"
            inactive-color="grey"
            disabled
          />
          <span v-else>-</span>
        </template>
      </el-table-column>
      <el-table-column label="备注" prop="exRemark" />
      <el-table-column label="所属硬件" prop="hardwareName" />
      <el-table-column label="创建时间" prop="createTime" width="180" :formatter="dateFormatter" />
      <el-table-column label="操作" align="center" width="150">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['mes:hw:key:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['mes:hw:key:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <Pagination
      v-model:total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗 -->
  <KeyForm ref="formRef" @success="getList" />
</template>

<script lang="ts" setup>
import { dateFormatter } from '@/utils/formatTime'
import * as KeyApi from '@/api/hw/hardware/keys/index'
import KeyForm from './KeyForm.vue'

defineOptions({ name: 'KeyInfo' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const showSearch = ref(true) // 是否显示搜索工作栏
const selectedIds = ref<number[]>([]) // 选中的数据编号

const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  keyCode: undefined,
  keyName: undefined,
  keyNfc: undefined,
  macAddress: undefined
})

const queryFormRef = ref() // 搜索表单

/** 查询钥匙列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await KeyApi.listKeyAPI(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields()
  handleQuery()
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: any[]) => {
  selectedIds.value = selection.map(item => item.id)
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id?: number) => {
  const ids = [id || selectedIds.value].join(',')
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await KeyApi.delKeyAPI(ids)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 初始化 **/
onMounted(async () => {
  await getList()
})
</script>
